"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: RegressionTests }"

TestCase subclass:#QDoubleTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'tests-regression'
!

!QDoubleTests class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        cg

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!QDoubleTests methodsFor:'tests'!

test99_misc
     self assert:( 1 asQDouble / (3 factorial) - (QDouble invFact at:1) ) = 0.0. 
     self assert:( 1 asQDouble / (4 factorial) - (QDouble invFact at:2) ) = 0.0. 
     self assert:( 1 asQDouble / (5 factorial) - (QDouble invFact at:3) ) = 0.0. 
     self assert:( 1 asQDouble / (6 factorial) - (QDouble invFact at:4) ) = 0.0. 
     self assert:( 1 asQDouble / (7 factorial) - (QDouble invFact at:5) ) = 0.0. 
     self assert:( 1 asQDouble / (8 factorial) - (QDouble invFact at:6) ) = 0.0. 
     self assert:( 1 asQDouble / (9 factorial) - (QDouble invFact at:7) ) = 0.0. 
     self assert:( 1 asQDouble / (10 factorial) - (QDouble invFact at:8) ) = 0.0. 
     self assert:( 1 asQDouble / (11 factorial) - (QDouble invFact at:9) ) = 0.0. 
     self assert:( 1 asQDouble / (12 factorial) - (QDouble invFact at:10) ) = 0.0. 
     self assert:( 1 asQDouble / (13 factorial) - (QDouble invFact at:11) ) = 0.0. 
     self assert:( 1 asQDouble / (14 factorial) - (QDouble invFact at:12) ) = 0.0. 
     self assert:( 1 asQDouble / (15 factorial) - (QDouble invFact at:13) ) = 0.0. 
     self assert:( 1 asQDouble / (16 factorial) - (QDouble invFact at:14) ) = 0.0. 
     self assert:( 1 asQDouble / (17 factorial) - (QDouble invFact at:15) ) = 0.0.

    "Created: / 20-06-2017 / 13:06:04 / cg"
!

test_01_instance_creation
    |q|

    q := QDouble fromFloat:1.0.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1.0 asQDouble.
    self assert:(q d0 = 1.0).
    self assert:(q d1 = 0.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e40 asQDouble + 1.0 asQDouble.
    self assert:(q d0 = 1e40).
    self assert:(q d1 = 1.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e40 asQDouble + 1.0.
    self assert:(q d0 = 1e40).
    self assert:(q d1 = 1.0).
    self assert:(q d2 = 0.0).
    self assert:(q d3 = 0.0).

    q := 1e120 asQDouble + 1e40 + 1.0.
    self assert:(q d0 = 1e120).
    self assert:(q d1 = 1e40).
    self assert:(q d2 = 1.0).
    self assert:(q d3 = 0.0).

    q := 1e200 asQDouble + 1e120 + 1e40 + 1.0.
    self assert:(q d0 = 1e200).
    self assert:(q d1 = 1e120).
    self assert:(q d2 = 1e40).
    self assert:(q d3 = 1.0).

    "
     self run:#test_01_instance_creation
     self new test_01_instance_creation
    "

    "Created: / 12-06-2017 / 17:03:46 / cg"
    "Modified: / 20-06-2017 / 07:48:51 / cg"
!

test_02_addition
    |d1 d2 l1 l2 sum_l q1 q2 sum_d sum_q|

    d1 := 1.0.
    d2 := 1.0e-16.
    sum_d := d1 + d2.
    "/ precision is lost with doubles!!
    self assert:( sum_d - 1.0 = 0.0 ).
    
    l1 := 1.0 asLongFloat.
    l2 := 1.0e-16 asLongFloat.
    sum_l := l1 + l2.
    "/ no precision is lost with long doubles!!
    self assert:( (sum_l - (1.0 asLongFloat)) > 0.0 ).

    l1 := 1.0 asLongFloat.
    l2 := 1.0e-30 asLongFloat.
    sum_l := l1 + l2.
    "/ precision is lost!!
    self assert:( (sum_l - (1.0 asLongFloat)) = 0.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:1.0e-16.
    sum_q := q1 + q2.
    
    "/ no precision is lost
    self assert:( (sum_q - (QDouble fromFloat:1.0)) > 0.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := q1 + q2.
    self assert:( sum_q = 3.0 ).
    
    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := q1 + 2.0.
    self assert:( sum_q = 3.0 ).

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:2.0.
    sum_q := 1.0 + q2.
    self assert:( sum_q = 3.0 ).

    q1 := 1e200 asQDouble + 1e120 + 1e40 + 1.0.
    q2 := 1e120.
    sum_q := q1 + q2.
    self assert:(sum_q d0 = 1e200).
    self assert:(sum_q d1 = 2e120).
    self assert:(sum_q d2 = 1e40).
    self assert:(sum_q d3 = 1.0).

    "
     self run:#test_02_addition
     self new test_02_addition
    "

    "Created: / 12-06-2017 / 17:05:07 / cg"
    "Modified: / 20-06-2017 / 07:49:32 / cg"
!

test_03_subtract
    |d1 d2 l1 l2 diff_l q1 q2 diff_d diff_q|

    d1 := 1.0.
    d2 := 0.99999.
    diff_d := d1 - d2.
    "/ precision is lost with doubles!!
    
    l1 := 1.0 asLongFloat.
    l2 := 0.99999 asLongFloat.
    diff_l := l1 - l2.
    "/ no precision is lost with long doubles!!

    q1 := QDouble fromFloat:1.0.
    q2 := QDouble fromFloat:0.99999.

    diff_q := q1 - q2.
    
    "
     self run:#test_03_subtract
     self new test_03_subtract
    "

    "Created: / 12-06-2017 / 23:12:00 / cg"
!

test_04_relops
    self assert:(1.0 = 1.0 asQDouble).
    self assert:(1.0 asQDouble = 1.0).
    self assert:(1.0 asQDouble = 1.0 asQDouble).

    self assert:(1 = 1 asQDouble).
    self assert:(1 asQDouble = 1).
    self assert:(1 asQDouble = 1 asQDouble).

    self assert:(1 = 1.0 asQDouble).
    self assert:(1.0 asQDouble = 1).
    self assert:(1.0 asQDouble = 1 asQDouble).
    
    self assert:(1.0 = 1 asQDouble).
    self assert:(1 asQDouble = 1.0).
    self assert:(1 asQDouble = 1.0 asQDouble).

    
    self deny:(1.0 = 1.1 asQDouble).
    self deny:(1.0 asQDouble = 1.1).
    self deny:(1.0 asQDouble = 1.1 asQDouble).

    self deny:(1 = 2 asQDouble).
    self deny:(1 asQDouble = 2).
    self deny:(1 asQDouble = 2 asQDouble).

    self deny:(1 = 2.0 asQDouble).
    self deny:(1.0 asQDouble = 2).
    self deny:(1.0 asQDouble = 2 asQDouble).

    self deny:(2.0 = 1 asQDouble).
    self deny:(2 asQDouble = 1.0).
    self deny:(2 asQDouble = 1.0 asQDouble).


    
    self assert:(1.0 < 1.1 asQDouble).
    self assert:(1.0 asQDouble < 1.1).
    self assert:(1.0 asQDouble < 1.1 asQDouble).

    self assert:(1 < 2 asQDouble).
    self assert:(1 asQDouble < 2).
    self assert:(1 asQDouble < 2 asQDouble).

    self assert:(1 < 2.0 asQDouble).
    self assert:(1.0 asQDouble < 2).
    self assert:(1.0 asQDouble < 2 asQDouble).

    self assert:(1.0 < 2 asQDouble).
    self assert:(1 asQDouble < 2.0).
    self assert:(1 asQDouble < 2.0 asQDouble).

    
    self deny:(1.0 < 1.0 asQDouble).
    self deny:(1.0 asQDouble < 1.0).
    self deny:(1.0 asQDouble < 1.0 asQDouble).

    self deny:(1 < 1 asQDouble).
    self deny:(1 asQDouble < 1).
    self deny:(1 asQDouble < 1 asQDouble).

    self deny:(1 < 1.0 asQDouble).
    self deny:(1.0 asQDouble < 1).
    self deny:(1.0 asQDouble < 1 asQDouble).

    self deny:(1.0 < 1 asQDouble).
    self deny:(1 asQDouble < 1.0).
    self deny:(1 asQDouble < 1.0 asQDouble).



    self assert:(2.0 > 1.1 asQDouble).
    self assert:(2.0 asQDouble > 1.1).
    self assert:(2.0 asQDouble > 1.1 asQDouble).

    self assert:(3 > 2 asQDouble).
    self assert:(3 asQDouble > 2).
    self assert:(3 asQDouble > 2 asQDouble).

    self assert:(3 > 2.0 asQDouble).
    self assert:(3.0 asQDouble > 2).
    self assert:(3.0 asQDouble > 2 asQDouble).

    self assert:(3.0 > 2 asQDouble).
    self assert:(3 asQDouble > 2.0).
    self assert:(3 asQDouble > 2.0 asQDouble).


    self deny:(1.0 > 3.0 asQDouble).
    self deny:(1.0 asQDouble > 3.0).
    self deny:(1.0 asQDouble > 3.0 asQDouble).

    self deny:(1 > 3 asQDouble).
    self deny:(1 asQDouble > 3).
    self deny:(1 asQDouble > 3 asQDouble).

    self deny:(1 > 3.0 asQDouble).
    self deny:(1.0 asQDouble > 3).
    self deny:(1.0 asQDouble > 3 asQDouble).

    self deny:(1.0 > 3 asQDouble).
    self deny:(1 asQDouble > 3.0).
    self deny:(1 asQDouble > 3.0 asQDouble).


    self assert:(1.0 <= 3.0 asQDouble).
    self assert:(1.0 asQDouble <= 3.0).
    self assert:(1.0 asQDouble <= 3.0 asQDouble).

    self assert:(1.0 <= 1.0 asQDouble).
    self assert:(1.0 asQDouble <= 1.0).
    self assert:(1.0 asQDouble <= 1.0 asQDouble).
    
    self assert:(2.0 >= 1.0 asQDouble).
    self assert:(2.0 asQDouble >= 1.0).
    self assert:(2.0 asQDouble >= 1.0 asQDouble).

    self assert:(1.0 >= 1.0 asQDouble).
    self assert:(1.0 asQDouble >= 1.0).
    self assert:(1.0 asQDouble >= 1.0 asQDouble).


    
    self assert: ((1.0 asQDouble + 1e-40) > 1.0 asQDouble).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-40)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-80)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-120)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-300)).
    self assert: (1.0 asQDouble < (1.0 asQDouble + 1e-300)).
    
    self assert: ((1.0 asQDouble + 1e-40) > 1.0).
    self assert: (1.0 < (1.0 asQDouble + 1e-40)).
    self assert: (1.0 < (1.0 asQDouble + 1e-80)).
    self assert: (1.0 < (1.0 asQDouble + 1e-120)).
    self assert: (1.0 < (1.0 asQDouble + 1e-300)).
    self assert: (1.0 < (1.0 asQDouble + 1e-300)).

    self assert: (1e10 asQDouble + 1.0) = 10000000001.0.
    "/ that's the problem with Floats...
    "/ (1e20 asQDouble + 1.0) ~= 100000000000000000001.0. 
    "/ (1e20 + 1.0) - 1e20 ~= 1.0. 
    self assert: (1e20 asQDouble + 1.0) - 1e20 = 1.0. 

    "/ here the precision of QDOubles is no longer enough:
    "/ self assert:  1.0 asQDouble < (1.0 asQDouble + 1e-310).

    "
     self run:#test_03_subtract
     self new test_03_subtract
    "

    "Created: / 13-06-2017 / 17:11:37 / cg"
    "Modified (comment): / 20-06-2017 / 09:18:50 / cg"
!

test_05_multiply
    |q1 q2 p|

    q1 := QDouble fromFloat:3.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    p := 2.0 * q1.

    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    q1 := QDouble fromFloat:2.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    p := q1 * 3.0.

    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    q1 := QDouble fromFloat:2.0. "/ DoubleArray(2.0 0.0 0.0 0.0)
    q2 := QDouble fromFloat:3.0. "/ DoubleArray(3.0 0.0 0.0 0.0)
    p := q1 * q2.
    
    self assert:(p d0 = 6.0).
    self assert:(p d1 = 0.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p = 6.0).
    self assert:(6.0 = p).

    "/ the 1 is not forgotten!!
    q1 := 1 asQDouble + 1e40.
    q2 := 2.0.
    p := q1 * q2.

    self assert:(p d0 = 2e40).
    self assert:(p d1 = 2.0).
    self assert:(p d2 = 0.0).
    self assert:(p d3 = 0.0).
    self assert:(p > 2e40).
    self assert:(p-2e40) = 2.0.

    "/ nothing is forgotten!!
    q1 := 1 asQDouble + 1e40 + 1e120.
    q2 := 2.0.
    p := q1 * q2.

    self assert:(p d0 = 2e120).
    self assert:(p d1 = 2e40).
    self assert:(p d2 = 2.0).
    self assert:(p d3 = 0.0).
    self assert:(p > 2e120).
    self assert:(p > (2e120 asQDouble + 2)).
    self assert:(p > (2e120 asQDouble + 1e40)).
    self assert:(p-2e120) = (2 asQDouble + 2e40).
    self assert:(p-2e120-2e40) = 2.0.

    "
     self run:#test_05_multiply
     self new test_05_multiply
    "

    "Created: / 19-06-2017 / 16:58:29 / cg"
    "Modified (comment): / 20-06-2017 / 07:42:52 / cg"
!

test_06_exp
    |f1 q1|

    f1 := 1.0 exp.
    q1 := 1.0 asQDouble exp.

    self assert:(q1 d0 = f1).

    "
     self run:#test_06_exp
     self new test_06_exp
    "

    "Created: / 19-06-2017 / 17:58:08 / cg"
!

test_07_reading
    |q1 s|

    q1 := QDouble readFrom: '3.1415926535897'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '                                        3.1415926535897').

    q1 := QDouble readFrom: '3.141592653589793238462643383'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '                          3.141592653589793238462643383').

    q1 := QDouble readFrom: '3.141592653589793238462643383279502884197169399375105820'.
    s := '%55.54f' printf:{ q1 }.
    self assert:(s = '3.14159265358979323846264338327950288419716939937510582').

    "
     self run:#test_07_reading
     self new test_07_reading
    "

    "Created: / 19-06-2017 / 23:29:34 / cg"
!

test_08_conversion
    |q i|
    
    q := 1e10 asQDouble + 1.0.
    i := q asInteger.

    self assert:(i = 10000000001).

    "
     self run:#test_08_conversion
     self new test_08_conversion
    "

    "Created: / 20-06-2017 / 07:51:50 / cg"
! !

!QDoubleTests class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

